



// MetaQuote [ MQ 4 ] 
//    IDENTIFICATION DIVISION    
//indicatordevelopment




                    #define   ProgramName         "Price Chart Cloning"
                    #define   SystemSymbol        "PCC"
                    #define   Author              "Keit Thomas Largo"
                    #define   eMail               "CockeyedCowboy@hotmail.com"
                    #define   LicenseTo           "WinSoft Technology  "
                    #define   ModuleType          "Indicator Development"
                    #define   DateWriten          "12.03.2009"
                    #define   VersionNumber       "1.00 B07 PB"
                    #define   ProgramLanguage     "MetaQuote  MQL v4.00, b225"
                    #define   SecurityLevel       "Public Document"
                    #define   Documentation       "none"
                    #define   CopyRight           "CopyRight    2009"




/* 	 COPYRIGHT NOTICE: 




                    The Price Bar Cloning indicator, its supportive files, and
                    any created files are CopyRighted material of  Keit Thomas
                    Largo and WinSoft Technology. You must treat this software
                    like any other copyrighted material. The Author has freely
                    released this  version of the  software to the  members of
                    the 'ForexTSD' Forum. As an aid in their 'OWN' PRIVATE and
                    PERSONAL trading operations. You are NOT permitted to rent
                    sell, resell, or otherwise distribute this software in any
                    profitable and or commercial endeavors without the written
                      permission of the author. No other rights are granded.

			                        ~~~ Keit Thomas Largo ~~~




//
//    ENVIRONMENT DIVISION    
//*/




                    #property              copyright          Author
                    #property              link                eMail

                    #property              indicator_separate_window
                    #property              indicator_buffers    2




//  DEFINED CONSTANT SECTION: 




                    #define                ScaleToAllBars             0
                    #define                ScaleToBarsInView          1
                    #define                ScaleNotApplied            2
                    #define                NewBars                    1
                    #define                UnKnown                   -1
                    #define                MaxBarCount             9999
                    #define                WickSize                   1
                    #define                BodySize                   3
                    #define                BoxColor          C'25,25,25'




//  EXTERN INPUT PARAMETER SECTION: 




            extern int
                DisplayBars         =   0,                ChartShift          =   0,
                TimeScale           =   0,                mladenCandle        =   0;


            extern string
                CurrencyPair        =  "";


            extern bool
                ShowOnMainChart     = False,
                ShowBidLine         =  True,              ShowOHLC            =  True;


            extern color
                UpBarColor          =   0,                DownBarColor        =   0,
                NuturlColor         =   0,                BidLineColor        =   0,
                mBoxColor           =   0;




//  GLOBAL SCOPE VARIABLES SECTION: 




            bool
                ErrorFound          =  False,             mladenBar           =  False,
                BidNeeded           =  False,             HeaderNeeded        =  False,
                MainUpDated         =  False,             CloneUpDated        =  False,
                DataDownLoaded      =  False;


            int
                DrawWindow          =   0,                ChartHistory        =   0,
                BarsOnChart         =   0,                BarsInView          =   0,
                BarsToChart         =   0,                BarsToScale         =   0,
                StartScaleAt        =   0,                LastScaleBar        =   0,
                HoldScale           =   0,                ScaleType           =   0,
                ReDrawBars          =   0;


            double
                HighPrice           =   0,                LowPrice            =   0,
                OpenPrice           =   0,                ClosePrice          =   0;


            string
                BarsName            =  "",                BarObject           =  "",
                IndicatorName       =  "",                UniqueID            =  "",
                SymbolWaterMark     =  "",                Portfolio           =  "",
                TimeString          =  "";


            datetime
                HoldTime            =   0,                LastBarTime         =   0,
                BarShift            =   0;


            color
                BarColor            =   0;




//  GLOBAL SCOPE ARRAYS SECTION: 




            double
                HighScale           [ ],                  LowScale            [ ];



            datetime
                TimeDataUpDate      [ ];




//
//    CONFIGURATION DIVISION    
void init(){//




            BarsInView    =  WindowFirstVisibleBar() -1;
            mladenCandle  =  MathMin( MathMax( mladenCandle, 0 ), BarsInView  );
            ChartShift    =  MathMin( MathMax( ChartShift,   0 ), BarsInView  );
            DisplayBars   =  MathMin( MathMax( DisplayBars,  0 ), MaxBarCount );

            if( CurrencyPair == "" )  { CurrencyPair  =   Symbol();  }
            if( TimeScale    ==  0 )  { TimeScale     =   Period();  }
            if( UpBarColor   ==  0 )  { UpBarColor    =   Green;     }
            if( DownBarColor ==  0 )  { DownBarColor  =   Red;       }
            if( NuturlColor  ==  0 )  { NuturlColor   =   Yellow;    }
            if( BidLineColor ==  0 )  { BidLineColor  =   DimGray;   }
            if( mBoxColor    ==  0 )  { mBoxColor     =   BoxColor;  }
            if( DrawWindow   ==  0 )  { DrawWindow    =   UnKnown;   }
            if( mladenCandle  >  0 )  { mladenBar     =   True;      }

            SymbolsToUpperCase( CurrencyPair );

            HoldScale       =  UnKnown;
            HoldTime        =  UnKnown;
            HeaderNeeded    =  True;
            BidNeeded       =  True;
            DataDownLoaded  =  False;
            ErrorFound      =  False;
            ScaleType       =  ScaleToAllBars;
            UniqueID        =  DoubleToStr( GetNumberID(), 0 );
            TimeString      =  CreateTimeString( TimeScale );
            IndicatorName   =  StringConcatenate( CurrencyPair, TimeString );
            BarObject       =  StringConcatenate( UniqueID, " ", SystemSymbol, " Bar Clone " );

            Portfolio       =  "USDJPY:USDCHF:USDCAD:AUDUSD:NZDUSD:EURCAD:EURAUD:AUDCAD:" +
                               "AUDNZD:EURGBP:EURJPY:EURCHF:GBPCHF:AUDJPY:CHFJPY:NZDJPY:" +
                               "GBPJPY:AUDCHF:EURNZD:GBPNZD:NZDCHF:GBPCAD:GBPUSD:EURUSD:" ;

            IndicatorBuffers  ( 2 );
            IndicatorShortName( IndicatorName );
            ArraySetAsSeries  ( TimeDataUpDate, True );

            SetIndexLabel ( 0, NULL      );
            SetIndexStyle ( 0, DRAW_NONE );
            SetIndexBuffer( 0, HighScale );

            SetIndexLabel ( 1, NULL      );
            SetIndexStyle ( 1, DRAW_NONE );
            SetIndexBuffer( 1, LowScale  );




return;}//
//    CODING DIVISION    
void start(){//



        if( VerifyPair( CurrencyPair ) && VerifyTime( TimeScale ))
            DownLoadDataUpDate( CurrencyPair, TimeScale, DataDownLoaded, TimeDataUpDate );

            if( ErrorFound  )  {  return;  }

            BarsInView    =  WindowFirstVisibleBar() -1;
            BarsOnChart   =  WindowBarsPerChart   () -1;
            ChartHistory  =  iBars  ( CurrencyPair, TimeScale ) -1;
            DisplayBars   =  MathMin( DisplayBars, ChartHistory );
            BarsToChart   =  MathMin( BarsInView - ChartShift, ChartHistory );
            LastBarTime   =  iTime  ( CurrencyPair, TimeScale, BarsToChart );
            BarsToScale   =  MathMin( BarsInView, BarsOnChart );
            StartScaleAt  =  MathMax( BarsToChart - BarsOnChart, 0 );

            SetChartParameters( DrawWindow, ScaleType,  DisplayBars, BarsToChart, BarsToScale );
            CreateChartScaling( ScaleType, CurrencyPair, TimeScale, BarsToScale, StartScaleAt );

            ReDrawBars  =  BarsToChart;

            if( DataDownLoaded && ( HoldTime  == LastBarTime ))  {  ReDrawBars  =  NewBars;  }

            for( int Bar = ReDrawBars; Bar >= 0; Bar -- ) {
                BarShift  =  OffSett( Bar, ChartShift, DrawWindow );
                BarsName  =  BarObject + DoubleToStr( Bar, 0 );

                CalculatePricePoints( CurrencyPair, TimeScale, Bar, mladenCandle );

                if( OpenPrice < ClosePrice )      {  BarColor  =  UpBarColor;    }
                else if( OpenPrice > ClosePrice ) {  BarColor  =  DownBarColor;  }
                else                              {  BarColor  =  NuturlColor;   }

                DrawWick( BarsName, DrawWindow, BarShift, HighPrice, LowPrice,   BarColor );
                DrawBody( BarsName, DrawWindow, BarShift, OpenPrice, ClosePrice, BarColor );

            } // End For Loop, Bar:

            RemoveUnNeededBars( BarObject, BarsToChart );
            ClonePriceBarChart( BarObject, DrawWindow, ChartShift );

            if( ShowBidLine && BidNeeded )
                DrawBidLine( BarObject, CurrencyPair, DrawWindow, BidLineColor );

            if( ShowOHLC && HeaderNeeded )
                ShowPricePoints( CurrencyPair, OpenPrice, HighPrice, LowPrice, ClosePrice );




return;}//
//    TERMINATION DIVISION     
void deinit(){//




                ClearAllBarGraphic( BarObject );




return;}//
//    PROCEDURAL DEFINITION DIVISION    
//




/*===============================================================================================|\
||                                                                                               ||
||        SymbolsToUpperCase Routine Procedure        v1.01        Date 11.26.2009       KTL     ||
||                                                                                               ||
||  Returns:     Nothing. But will change the symbol string to upper case by referance.          ||
||                                                                                               ||
||  Purpose:     It changes any lower case characters in the currency symbol to upper case. This ||
||               will only change the first 6 characters to upper case which should address the  ||
||               the brokers that use trailing lower case symbols for micro accounts. What ever  ||
||               is after the 6th character is left unchanged.                                   ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    SymbolsToUpperCase( string& Currency ) {
        int    Index              =     0;
        int    Character          =     0;
        string UpperCase          =    "";

            if( ShowOnMainChart || mladenBar )   {  Currency  =  Symbol();   return;  }

            for( Index = 0; Index < 6; Index ++ ) {

                Character  =  StringGetChar( Currency, Index );
                if( Character >= 97 && Character <= 122 )  {  Character  =  Character - 32;  }
                UpperCase  =  UpperCase + CharToStr( Character );

            } // End For Loop, Index:

            Currency  =  UpperCase + StringSubstr( Currency, 6 );

    return;

} // End Function Procedure, SymbolsToUpperCase:




/*===============================================================================================|\
||                                                                                               ||
||        GetNumberID Function Procedure          v2.70        Date 02.23.2007       KTL         ||
||                                                                                               ||
||  Returns:     An 'int type' three digit number from 101 to 999.                               ||
||                                                                                               ||
||  Purpose:     To give each chart its own, object unique identification number. To prevent the ||
||               indicator from interferring with any other objects that exist.                  ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
int
    GetNumberID() {
        int PullNumber      =  101;

            if( GlobalVariableCheck( "PullNumber ( Do Not Delete )" ))
                PullNumber  =  GlobalVariableGet( "PullNumber ( Do Not Delete )" );

            GlobalVariableSet( "PullNumber ( Do Not Delete )", PullNumber + 1 );

            if( GlobalVariableGet( "PullNumber ( Do Not Delete )" ) > 999 )
                GlobalVariableSet( "PullNumber ( Do Not Delete )", 101 );

    return( PullNumber );

} // End Function Procedure, GetNumberID:




/*===============================================================================================|\
||                                                                                               ||
||        CreateTimeString Function Procedure         v1.00        Date 11.24.2009       KTL     ||
||                                                                                               ||
||  Returns:     Returns a string of the time frame of the data in the chart.                    ||
||                                                                                               ||
||  Purpose:     To match the header display of the MQ Charts.                                   ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
string
    CreateTimeString( int TimeInput ) {
        string   StringOutput    =   "";

            if( TimeInput == 0 )  {  TimeInput  =  Period();  }

                switch( TimeInput ) {
                    case 1:       StringOutput  =  ",M1";       break;
                    case 5:       StringOutput  =  ",M5";       break;
                    case 15:      StringOutput  =  ",M15";      break;
                    case 30:      StringOutput  =  ",M30";      break;
                    case 60:      StringOutput  =  ",H1";       break;
                    case 240:     StringOutput  =  ",H4";       break;
                    case 1440:    StringOutput  =  ",Daily";    break;
                    case 10080:   StringOutput  =  ",Weekly";   break;
                    case 43200:   StringOutput  =  ",Monthly";  break;
                    default:      StringOutput  =  ",UnKnown";  break;

                } // End Switch Case, TimeInput:

    return( StringOutput );

} // End Function procedure, CreateTimeString:




/*===============================================================================================|\
||                                                                                               ||
||        VerifyPair Function Procedure         v1.02        Date 11.28.2009          KTL        ||
||                                                                                               ||
||  Returns:     Will return True if the input for currency pair is listed in the Portfolio of   ||
||               tradable currencies. False will be returned if it is not in the protfolio.      ||
||                                                                                               ||
||  Purpose:     It will verify and warn of an incorrect user input for the chart symbol. It     ||
||               will print an error message to an empty indicator window. Displaying the symbol ||
||               that was typed.                                                                 ||
||                                                                                               ||
||  Note:        To add new Currencies to the portfolio just add its symbol name to the end of   ||
||               the list With no spaces and terminate it with a colon. WARRING: Any symbol that ||
||               is added  that is not part of your brokers offerings will attemp to download    ||
||               that data unseccesfully. If say AUDMXN is entered and that is not offered by    ||
||               your broker this will not trigger an error. So be aware of adding an odd symbol ||
||               to the list. This check doesnot stop all errors that can occour. One can create ||
||               a portfolio of symbols that he trades by rewriting the portfolio variable to    ||
||               his trade currencies. Corrected an error when the Pair equaled the symbol which ||
||               returned as False. in the first line. and removed the log statements.           ||
||                                                                                               ||
||               This function by the way looks at the symbol in two parts each consisting of    ||
||               each country. This is done in this manner because other bar indicaters I have   ||
||               look at one country verses all other countries in a series one at a time. In    ||
||               indicater theres no need for this however I left it in place.                   ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
bool
    VerifyPair( string Pair ) {
        int      Pass           =     0;
        int      C1             =     0;
        int      C2             =     0;
        int      Count          =     0;
        string   PartOne        =    "";
        string   PartTwo        =    "";

            if( Pair == Symbol() )  {  return( True );  }

                Count    =  StringLen( Portfolio ) / 7;
                PartOne  =  StringSubstr( Pair, 0, 3 );
                PartTwo  =  StringSubstr( Pair, 3, 3 );

                    for( Pass = 0, C1 = 0, C2 = 3; Pass <= Count; Pass ++, C1 += 7, C2 += 7 )
                        if( PartOne == StringSubstr( Portfolio, C1, 3 ) &&
                            PartTwo == StringSubstr( Portfolio, C2, 3 ))   {  return( True );  }

                ErrorFound  =  True;
                IndicatorShortName ( " ERROR   NO SYMBOL [ " + Pair + " ] IN YOUR PORFOLIO." );

    return( False );

} // End Function Procedure, VerifyPair:




/*===============================================================================================|\
||                                                                                               ||
||        VerifyTime Function Procedure         v1.01        Date 11.26.2009          KTL        ||
||                                                                                               ||
||  Returns:     Returns True if the time frame input matches one of MTs chart time scales. Only ||
||               MTs chart scales periods can be used in this version. False will be return if a ||
||               nor MT time scale is used.                                                      ||
||                                                                                               ||
||  Purpose:     It will verify and warn of an incorrect user input for the chart period. It     ||
||               will print the period that the user entered, and on error, will print an error  ||
||               message to an empty indicator window. Removed the log statments.                ||
||                                                                                               ||
||  Note:        It is very posible to create any time period to chart with this indicator but   ||
||               this functionality is not builted into this indicator.                          ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
bool
    VerifyTime ( int Frame ) {

        switch( Frame ) {
            case 0:          case PERIOD_M1:  case PERIOD_M5:  case PERIOD_M15:  case PERIOD_M30:
            case PERIOD_H1:  case PERIOD_H4:  case PERIOD_D1:  case PERIOD_W1:   case PERIOD_MN1:

            return( True );

            default:
                ErrorFound  =  True;
                IndicatorShortName( " ERROR   INCORRECT TIME SCALE  [ M" + Frame +
                                    " ]  WAS ENTERED." );

        } // End Switch Case, TimeFrame:

    return( False );

} // End Function Procedure, VerifyTime:




/*===============================================================================================|\
||                                                                                               ||
||        DownLoadDataUpDate Routine Procedure    v1.30    Date 12.02.2009         KTL           ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     To update the data before scaling and drawing the price charts.                 ||
||                                                                                               ||
||  Note:        We need to know the highs and lows of the data before we can scale the charts.  ||
||               If the charts are scaled before the new data is known the results will have     ||
||               bars outside the chart limits. If you get a DownLoad Timeed Out error you will  ||
||               have to refressh the indicator and it will try again. This function has been    ||
||               greatly rewriten and in addition of an off line routine and warnings if the     ||
||               chart data is not up todate. This warning is only to indicate that the charts   ||
||               that your looking at are not equal in there last bar time and should not be     ||
||               relied on. If you connect even when the markets are closed it should update the ||
||               charts to current or uptill the close of the market. The down load routine was  ||
||               changed to a while loop with a break exit, out of the loop if the download is   ||
||               completed. The download routine makes 60 download calls to the data server on   ||
||               each of 3 attempts one attempt on each of 3 new incoming ticks, if this is      ||
||                                                                                               ||
||               un-seccessful you will get a time out error which will indicate that the three  ||
||               attampts have ended. Most other error notices were removed as this type of loop ||
||               printed to your log records on each loop of the code creating very large log    ||
||               files. The bar it checks has been changed back to Bar[0], from the bar in view, ||
||               Bar[BarsInView] I saw no benefit in either mode. I have not seen this version   ||
||               of the down load go into attempt 2 yet and I think its working as intended.     ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    DownLoadDataUpDate( string Pair, int Frame, bool& DataDownLoaded, datetime& TimeUpDate[] ) {
        int          DownLoadRetry    =   0;
        static int   Attempts         =   1;
        datetime     MainLastUpDate   =   0;
        datetime     CloneLastUpDate  =   0;
        datetime     BaseTimePeriod   =   0;

            if( IsConnected() ) {
                if( DataDownLoaded )  {   return;   }
                RefreshRates();
                ErrorFound   =  True;
                MainUpDated  =  True;

                while( ! DataDownLoaded && Attempts <= 3 ) {
                    ArrayCopySeries( TimeUpDate, MODE_TIME, Pair, Frame );
                    BaseTimePeriod  =  iTime( Pair, Frame, 0 );
                    ErrorFound      =  True;
                    HoldScale       =  UnKnown;
                    HoldTime        =  UnKnown;
                    DownLoadRetry ++;

                    if( TimeUpDate[ 0 ] == BaseTimePeriod ) {
                        CloneUpDated    =  True;
                        DataDownLoaded  =  True;
                        ErrorFound      =  False;
                        break;

                    } // End If, TimeUpDate:

                    if( DownLoadRetry >= 60 ) {
                        IndicatorShortName ( " ERROR   DOWN LOADER HAS TIMED OUT " +
                                             "IN [ " + Attempts + " ] ATTEMPT(s)." );
                        Attempts ++;   break;

                    } // End If, TimeUpDate:
                } // End While Loop, Attempt:

            } else {
                MainLastUpDate   =  iTime( Symbol(), Period(), 0 ) + ( Period() * 60 );
                CloneLastUpDate  =  iTime( Pair, Frame, 0 ) + ( Frame * 60 );

                    if( MainLastUpDate  > TimeCurrent() ) {  MainUpDated   =  True;  }
                    if( CloneLastUpDate > TimeCurrent() ) {  CloneUpDated  =  True;  }

                        OffLineWarnings( BarObject, MainUpDated );

            } // End If, IsConnected:

    return;

} // End Routine Procedure, DownLoadDataUpDate:




/*===============================================================================================|\
||                                                                                               ||
||        OffLineWarnings Routine Procedure        v1.00         Date 11.26.2009       KTL       ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     Gives user notice of offline conditions and chart updating.                     ||
||                                                                                               ||
||  Note:        Chart updating is determined by the last server time, it doesnot really tell    ||
||               if the charts are out dated but if the charts are up todate in referance with   ||
||               the last server time. This is nessecary as you can have two charts on the same  ||
||               currency with time frames and both could have different ending (bid) prices and ||
||               times. The problem is worse if your looking at two different currencies as both ||
||               could be weeks appart. Depending on when each chart was last used / updated.    ||
||               This only shows up off line. (something the MT doesnot tell you about)          ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    OffLineWarnings( string Name, bool MainCurrent ) {
        string    MainWarning  =  "WARNING:  Main  Chart  Is  Out  Dated.";

            ObjectCreate ( Name + " Off Line", OBJ_LABEL, 0, 0, 0 );
            ObjectSetText( Name + " Off Line", "OFF LINE", 10, "Arial", White );
                ObjectSet( Name + " Off Line", OBJPROP_CORNER,       1 );
                ObjectSet( Name + " Off Line", OBJPROP_XDISTANCE,   92 );
                ObjectSet( Name + " Off Line", OBJPROP_YDISTANCE,    3 );
                ObjectSet( Name + " Off Line", OBJPROP_BACK,     False );

            if( ! MainCurrent  ) {
                ObjectCreate ( Name + " Main Chart", OBJ_LABEL, 0, 0, 0 );
                ObjectSetText( Name + " Main Chart", MainWarning, 8, "Arial", LightSalmon );
                    ObjectSet( Name + " Main Chart", OBJPROP_CORNER,       1 );
                    ObjectSet( Name + " Main Chart", OBJPROP_XDISTANCE,   29 );
                    ObjectSet( Name + " Main Chart", OBJPROP_YDISTANCE,   15 );
                    ObjectSet( Name + " Main Chart", OBJPROP_BACK,     False );

            } // End If, MainUpDated:

    return;

} // End Routine Procedure, OffLineWarnings:




/*===============================================================================================|\
||                                                                                               ||
||        SetChartParameters Routine Procedure         v1.20      Date 12.03.2009       KTL      ||
||                                                                                               ||
||  Returns:     Nothing, However it changes some of the varables values as most are pasted by   ||
||               reference which in effect has the ability of returning different values.        ||
||                                                                                               ||
||  Purpose:     This is a multi purpose procedure, it has to determine which window that it     ||
||               will paint the bars on and the type of scaling it will use, if any or the type  ||
||               chart layout.                                                                   ||
||                                                                                               ||
||  Note:        This indicator can paint to its own window and is the typical format, However   ||
||               It can also paint on an existing window if we use the MT drag and drop on to an ||
||               existing window. We can also paint on to the main chart window as well.         ||
||                                                                                               ||
||    version 1.00 b03 was added the mladen bar.                                                 ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    SetChartParameters( int& Window, int& Type, int& Display, int& BarsChart, int& BarsScale ) {

            if( mladenBar ) {
                Display       =  1;
                HeaderNeeded  =  False;
                BidNeeded     =  False;
                Window        =  0;
                Type          =  ScaleNotApplied;

            } // End If, mladenBar:

            if( Display > 0 ) {
                if( Display <= BarsScale )   {   Type  =  ScaleToBarsInView;   }

                BarsChart  =  Display -1;
                BarsScale  =  MathMin( BarsScale, Display );

            } // End If, DisplayBars:

            if( ShowOnMainChart && ! mladenBar ) {
                if( Display <= 0 && BarsChart < BarsInView + ChartShift  )
                    BarsChart += ( 2 * ChartShift );

                    HeaderNeeded  =  False;
                    BidNeeded     =  False;
                    Window        =  0;
                    Type          =  ScaleNotApplied;

            } // End If, ShowOnMainChart:

            if( Window  == UnKnown ) {
                Window  =  WindowFind( IndicatorName );

                if( Window  == UnKnown ) {
                    Window     =  WindowOnDropped();
                    Type       =  ScaleNotApplied;
                    BidNeeded  =  False;

                    if( Window  == UnKnown ) {
                        ErrorFound  =  True;
                        IndicatorShortName( " ERROR   OCCURED IN ALLOCATION OF WINDOW." );

                    } // End If, Window:
                } // End If, Window:
            } // End If, Window:

    return;

} // End Routine Procedure, SetChartParameters:




/*===============================================================================================|\
||                                                                                               ||
||        CreateChartScaling Routine Procedure        v1.30        Date 12.03.2009       KTL     ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     To scale the chart window to the highest and lowest values that will appear     ||
||               within the bars in view.  Not all the data will be used. Only the bars in view. ||
||                                                                                               ||
||  Note:        The indicator doesnot normally draw any more then the bars within the charts    ||
||               current view. This was done to save time. If however one scrolls the chart to   ||
||               the left, new bars will be painted and the chart rescaled to those new bars as  ||
||               they come into view. you can scroll to the end of your data history and draw    ||
||               all the bars contained in your history up to the point of the MaxBarCount limit ||
||               which is set to 10,000 bars. Any bars in history that is larger then that will  ||
||               not get drawn. This limit has been reduced from 100,000 to 10,000 as MT takes   ||
||               too long to retreive history data. Causing the indicator repeated time outs.    ||
||                                                                                               ||
||               Even though we do not need any buffers for this indicator, we have to define    ||
||               two of them to properly scale the chart window. They produce no output. In      ||
||               v 1.00 b02 Was added 2 methods of scaling and the ability to bypass scaling all ||
||               together. The reason is when we are looking at more then one screen full of     ||
||               data it is best to scale the full history of the chart at one time, however     ||
||               when looking at less then a screen full of data it is best to scale the chart   ||
||               to just the data that is in view. Neither scale type is good for all conditions ||
||               and if the bars are to be ploted on an exsiting cart, then no scaling is done   ||
||               as any scaling will have no effect the second plot takes the scale of the first ||
||               chart that exist. so scaling under this condition is a waste of time.           ||
||                                                                                               ||
||      Scale Type:                                                                              ||
||    ScaleToAllBars    0 = Scaled as a regular high low buffer indicator. Default type used.    ||
||   ScaleToBarsInView  1 = The highest and lowest bar of chart view only is used for scaling.   ||
||    ScaleNotApplied   2 = No scaling needed will use on prevest scale of existing window.      ||
||                                                                                               ||
||               Changes were made to get this scaling procedure to rescale the charts on data   ||
||               downloads on both cases of ScaleToBarsInView and ScaleToAllBars. MT has the     ||
||               of going ahead of itself even when its downloading data. This is the problem    ||
||               that I was trying to work around. Even the main chart you will see that it to   ||
||               scales and draws itself before all data in known, then the chart jumps to the   ||
||               new data and rescales to that data. I have used the same method and rescales    ||
||               the chart up to 10 times to be sure that the end results are the final ones.    ||
||               The scaling now will take place in steps and will scale and draw the charts     ||
||               and rescale and redraw itself much the way that MT own charts do.               ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    CreateChartScaling( int Type, string Pair, int Frame, int ScaleBars, int ScaleStart ) {
        int         ScaleToBars     =   NewBars;
        int         Index           =   0;
        int         HighestBar      =   0;
        int         LowestBar       =   0;
        double      HighestPrice    =   0;
        double      LowestPrice     =   0;

            switch( Type ) {
                case ScaleToBarsInView:
                    HighestBar    =  iHighest( Pair, Frame, MODE_HIGH, ScaleBars, ScaleStart );
                    LowestBar     =  iLowest ( Pair, Frame, MODE_LOW,  ScaleBars, ScaleStart );
                    HighestPrice  =  iHigh   ( Pair, Frame, HighestBar );
                    LowestPrice   =  iLow    ( Pair, Frame, LowestBar  );

                        ArrayInitialize( HighScale, EMPTY_VALUE );
                        ArrayInitialize( LowScale,  EMPTY_VALUE );

                            for( Index = ScaleStart; Index <= ScaleBars; Index ++ ) {
                                HighScale[ Index ]  =  HighestPrice;
                                LowScale [ Index ]  =  LowestPrice;

                                HighScale[ Index + ChartShift ]  =  HighestPrice;
                                LowScale [ Index + ChartShift ]  =  LowestPrice;

                            } // End For Loop, BarIndex:

                    HoldScale  =  UnKnown;
                    break;

                case ScaleToAllBars:
                    if( HoldScale < 10 )  {  ScaleToBars  =  ChartHistory;  HoldScale ++;  }

                        for( Index = ScaleToBars; Index >= 0; Index -- ) {
                            HighestPrice  =  iHigh( Pair, Frame, Index );
                            LowestPrice   =  iLow ( Pair, Frame, Index );

                                HighScale[ Index ]  =  HighestPrice;
                                LowScale [ Index ]  =  LowestPrice;

                        } // End For Loop, BarIndex:

                    ScaleToBars  =  NewBars;
                    break;

                case ScaleNotApplied:
                    HoldScale  =  UnKnown;
                    break;

            } // End Switch Case, Type:

    return;

} // End Routine Procedure, CreateChartScaling:




/*===============================================================================================|\
||                                                                                               ||
||        OffSett Function Procedure             v1.01             Date 11.29.2009       KTL     ||
||                                                                                               ||
||  Returns:     The Bar Time value of the main chart.                                           ||
||                                                                                               ||
||  Purpose:     The bar time of any bar no mater what chart your appling has to line up with    ||
||               the main chart time not the bars of the applied chart.                          ||
||                                                                                               ||
||  Note:        If you apply charts as an indicator it will paint the bars based on there time  ||
||               in referance to the main chart. say you paint M5 bars were the main chart is a  ||
||               M60 chart. The results would be 20 bars painted on top of each other. Or reverse||
||               apply a M60 chart on a M5 main chart and you will get one M60 bar for ever 20   ||
||               bars spacing of the main chart. This function alines each bar of the applied    ||
||               chart with each bar of the main chart, adjusted of course for any chart shift.  ||
||                                                                                               ||
||               All shifting of charts on indicator windows is done to the LEFT of the ZERO bar.||
||               Except if the applied chart is put on the main chart window, then the shift     ||
||               will always be to the RIGHT of the ZERO bar. This shift works independendly of  ||
||               the MT shift button.                                                            ||
||                                                                                               ||
||               On the MT plateform any bar to the right of the zero bar must be addressed by   ||
||               adding the time equalivent of one bar's time to the zero bar to access each bar.||
||               That is, the time adjustment variable that was added to this function. However  ||
||               one can NOT access the bars after the zero bar (bars greater then and to the    ||
||               left of the zero bar) by the same means as it gets into problems when the       ||
||               sunday / monday open comes arround. theres more or less time differences in     ||
||               bars around the market close. This was the reason for the errors in charting on ||
||               version 1.00 b04. In this version, bars that are smaller then the shift amount  ||
||               are adjusted by the time element and the ones greater to or equal are adjusted  ||
||               backwards by the bar shift count. There still appears a space in the bars to    ||
||               right of the zero bar when it encouners the weekend bar times, however it does  ||
||               paint every bar correctly, and I have not found a way to close that gap in the  ||
||               bars. Therefore you may see a space between bars that are paint to the right of ||
||               zero bar. Its not a missing bar but MTs closed bar count. It will only happen   ||
||               on the main chart when shifting the chart to the right of the zero bar. all     ||
||               bar drawing will not be effected by the closed bar.                             ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
datetime
    OffSett( int BarCount, int Shift, int Window ) {
        datetime     TimeValue    =   0;
        datetime     TimeAdjust   =   0;

            Shift       =  MathAbs( Shift );
            TimeValue   =  Time[ BarCount + Shift ]; 
            TimeAdjust  =  Period() * 60 * Shift;

            if( Window  == 0 ) {
                if( BarCount <  Shift )  {   TimeValue  =  Time[ BarCount ] + TimeAdjust;   }
                if( BarCount >= Shift )  {   TimeValue  =  Time[ BarCount - Shift ];        }

            } // End If, Window:

    return( TimeValue );

} // End Function Procedure, OffSett:




/*===============================================================================================|\
||                                                                                               ||
||        CalculatePricePoints Routine Procedure        v1.00        Date 11.20.2009      KTL    ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     It creates the price points to draw the bars from.                              ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    CalculatePricePoints( string Currency, int Frame, int Number, int mCandle ) {
        int HighBar     =   0;
        int LowBar      =   0;

            switch( mladenBar ) {
                case True:
                    HighBar  =  iHighest( Symbol(), Period(), MODE_HIGH, mCandle );
                    LowBar   =  iLowest ( Symbol(), Period(), MODE_LOW,  mCandle );

                    OpenPrice   =  Open [ mCandle ];
                    HighPrice   =  High [ HighBar ];
                    LowPrice    =  Low  [ LowBar  ];
                    ClosePrice  =  Close[ Number  ];

                    break;

                default:
                    OpenPrice   =  iOpen ( Currency, Frame, Number );
                    HighPrice   =  iHigh ( Currency, Frame, Number );
                    LowPrice    =  iLow  ( Currency, Frame, Number );
                    ClosePrice  =  iClose( Currency, Frame, Number );

            } // End Switch Case, mladenBar:

    return;

} // End Routine Procedure, CalculatePricePoints:




/*===============================================================================================|\
||                                                                                               ||
||        DrawWick Routine Procedure          v1.04           Date 11.27.2009          KTL       ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     Draws out the wick part of the bars.                                            ||
||                                                                                               ||
||  Note:        See note in the DrawBody Routine Procedure. It applys here too.                 ||
||               This version has the mladen candle and the ability to draw a box that contains  ||
||               the bars that make up the candle. Added ObjectFind before Deleting object as it ||
||               was causing getlasterror() to retrun an error if the object didnot exist.       ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    DrawWick( string Name, int Window, datetime bShift, double hPrice, double lPrice, color bColor ) {

        if( ObjectFind( Name + "   Wick" ) != -1 )   {   ObjectDelete( Name + "   Wick" );   }
        if( ObjectFind( Name +    " Box" ) != -1 )   {   ObjectDelete( Name +    " Box" );   }

            ObjectCreate ( Name + "   Wick", OBJ_TREND, Window, bShift, lPrice, bShift, hPrice );
                ObjectSet( Name + "   Wick", OBJPROP_COLOR, bColor      );
                ObjectSet( Name + "   Wick", OBJPROP_WIDTH, WickSize    );
                ObjectSet( Name + "   Wick", OBJPROP_STYLE, STYLE_SOLID );
                ObjectSet( Name + "   Wick", OBJPROP_RAY,   False       );
                ObjectSet( Name + "   Wick", OBJPROP_BACK,  False       );

            if( mladenBar ) {
                ObjectCreate ( Name + " Box", OBJ_RECTANGLE, Window,
                         Time[ 0 ], lPrice,  Time[ mladenCandle -1 ], hPrice );
                    ObjectSet( Name + " Box", OBJPROP_COLOR, mBoxColor );
                    ObjectSet( Name + " Box", OBJPROP_BACK,  True      );

            } // End If, mladenBar:

    return;

} // End Routine Procedure, DrawWick:




/*===============================================================================================|\
||                                                                                               ||
||        DrawBody Routine Procedure          v1.01          Date 11.27.2009          KTL        ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     Draws out the body part of the bars.                                            ||
||                                                                                               ||
||  Note:        The 3 spaces in the Name --   "123Body"   -- in this procedure are needed to    ||
||               give room for the bar numbers. If we remove these spaces the indicator will not ||
||               be able to read the ID numbers correctly and would not be able to delete the    ||
||               bars when the time comes to remove them. The largest bar count permitted is     ||
||               9,999 bars. or 10,000 with the zero bar. Therefore DONT REMOVE THESE SPACES.    ||
||               Added ObjectFind before Deleting object as it was causing getlasterror() to     ||
||               retrun an error on occation when the object didnot exist.                       ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    DrawBody( string Name, int Window, datetime bShift, double oPrice, double cPrice, color bColor ) {

        if( ObjectFind( Name + "   Body" ) != -1 )   {   ObjectDelete( Name + "   Body" );   }

            ObjectCreate ( Name + "   Body", OBJ_TREND, Window, bShift, oPrice, bShift, cPrice );
                ObjectSet( Name + "   Body", OBJPROP_COLOR, bColor      );
                ObjectSet( Name + "   Body", OBJPROP_WIDTH, BodySize    );
                ObjectSet( Name + "   Body", OBJPROP_STYLE, STYLE_SOLID );
                ObjectSet( Name + "   Body", OBJPROP_RAY,   False       );
                ObjectSet( Name + "   Body", OBJPROP_BACK,  False       );

    return;

} // End Routine Procedure, DrawBody:




/*===============================================================================================|\
||                                                                                               ||
||  RemoveUnNeededBars Routine Procedure         v1.01         Date 11.27.2009        KTL        ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     This Routine will remove all bars that extend past the last visiable bar on the ||
||               left side of the Chart as we scroll back to the right.                          ||
||                                                                                               ||
||  Note:        As noted in the CreateChartScaling Procedure the indicator will draw new bars   ||
||               as you scroll the chart to the left as new bars come into view. This procedure  ||
||               will remove these bars as you scroll the chart back to the right, as they come  ||
||               out of view. No bars are ever removed from the right edge of the chart even if  ||
||               they are not within the current chart view, as it is assumed the chart will be  ||
||               returned to the right edge of the chart. This function only deals with the bars ||
||               that this copy created. Any bars that was created with another copy of this     ||
||               same indicator will not be removed. Added ObjectFind before Deleting object as  ||
||               it was causing getlasterror() to retrun an error if the object didnot exist.    ||
||               added for the removal of off line objects.                                      ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    RemoveUnNeededBars( string Object, int BarsSeen ) {

        IndicatorShortName( "" );

        if( ObjectFind( Object + " Bid Line" ) != -1 )   {   ObjectDelete( Object + " Bid Line" );   }

        if( IsConnected() ) {
            if( ObjectFind( Object + " Off Line"   ) != -1 ) { ObjectDelete( Object + " Off Line"   ); }
            if( ObjectFind( Object + " Main Chart" ) != -1 ) { ObjectDelete( Object + " Main Chart" ); }

        } // End If, IsConnected:

            for( int Count = ObjectsTotal(); Count >= 0; Count -- )

                if( StringSubstr( ObjectName( Count ), 0, 18 ) == Object )

                    if( StrToInteger( StringSubstr( ObjectName( Count ), 18, 5 )) > BarsSeen )
                        ObjectDelete( ObjectName( Count ));

    return;

} // End Routine Procedure, RemoveUnNeededBars:




/*===============================================================================================|\
||                                                                                               ||
||        ClonePriceBarChart Routine Procedure      v1.00       Date 11.11.2009         KTL      ||
||                                                                                               ||
||  Returns:     nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     Sets the copyright notice at the lower left corner of the chart window. It can  ||
||               be used in debuging as well, see note below.                                    ||
||                                                                                               ||
||  Note:        When useing the mladen bar option a notice of its origin is displaied on the    ||
||               chart to give credit to its originator.                                         ||
||                                                                                               ||
||               The Lower Object is used in development of the indicator, and is not shown in   ||
||               use. It exposes the bars in View(BIV) and the bar on chart (BOC) numbers for    ||
||               development purposes only and have no value otherwise. To view just REM OUT the ||
||               first return statment.                                                          ||
||                                                                                               ||
||               This routine was also intended to handle the chart hosting verses child charts  ||
||               however this was one limitation of MT I have not been able to work around yet.  ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    ClonePriceBarChart( string Name, int Window, int Shift ) {
        int       Move           =  124;
        string    BarStats       =   "";
        string    ChartClone     =   "";
        string    mladenCredit   =   "";

            HoldTime      =  LastBarTime;
            BarStats      =  "[ BIV : " + BarsInView + "  -  BOC : " + BarsOnChart + " ]";
            ChartClone    =  ProgramName + "    " + CopyRight + "    " + Author;
            mladenCredit  =  "mladen Candle";
            Move         -=  ( Shift * 4 );

                ObjectCreate ( Name + " Clone", OBJ_LABEL, Window, 0, 0 );
                ObjectSetText( Name + " Clone", ChartClone, 6, "Arial", DimGray );
                    ObjectSet( Name + " Clone", OBJPROP_CORNER,       2 );
                    ObjectSet( Name + " Clone", OBJPROP_XDISTANCE,    5 );
                    ObjectSet( Name + " Clone", OBJPROP_YDISTANCE,    3 );
                    ObjectSet( Name + " Clone", OBJPROP_BACK,      True );

                if( mladenBar ) {
                    ObjectCreate ( Name + " mladen", OBJ_LABEL, Window, 0, 0 );
                    ObjectSetText( Name + " mladen", mladenCredit, 10, "Arial", DimGray );
                        ObjectSet( Name + " mladen", OBJPROP_CORNER,       3 );
                        ObjectSet( Name + " mladen", OBJPROP_XDISTANCE, Move );
                        ObjectSet( Name + " mladen", OBJPROP_YDISTANCE,    3 );
                        ObjectSet( Name + " mladen", OBJPROP_BACK,      True );
                 } // End If, mladenBar:

    return;

                ObjectCreate ( Name + " Stats", OBJ_LABEL, Window, 0, 0 );
                ObjectSetText( Name + " Stats", BarStats, 8, "Arial", DimGray );
                    ObjectSet( Name + " Stats", OBJPROP_CORNER,       2 );
                    ObjectSet( Name + " Stats", OBJPROP_XDISTANCE,  250 );
                    ObjectSet( Name + " Stats", OBJPROP_YDISTANCE,    3 );
                    ObjectSet( Name + " Stats", OBJPROP_BACK,      True );

    return;

} // End Routine Procedure, ClonePriceBarChart:




/*===============================================================================================|\
||                                                                                               ||
||        DrawBidLine Routine Procedure        v1.00        Date 11.11.2009         KTL          ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     Draws the bid line on the chart.                                                ||
||                                                                                               ||
||  Note:        This routine will draw the bid line if the extern input is true, and included   ||
||               to mantain compatibility with MQ chart displays. If two or more charts are put  ||
||               on one chart or if applied to the main chart plain the bid line will be turned  ||
||               off on the extra charts automaticly as only one is really needed.               ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    DrawBidLine( string Name, string Pair, int Window, color LineColor ) {

        ObjectCreate( Name + " Bid Line", OBJ_HLINE,     Window,
                Time[ 0 ], MarketInfo( Pair, MODE_BID ));

           ObjectSet( Name + " Bid Line", OBJPROP_COLOR,   LineColor );
           ObjectSet( Name + " Bid Line", OBJPROP_WIDTH,           1 );
           ObjectSet( Name + " Bid Line", OBJPROP_STYLE, STYLE_SOLID );
           ObjectSet( Name + " Bid Line", OBJPROP_BACK,         True );

    return;

} // End Routine Procedure, DrawBidLine:




/*===============================================================================================|\
||                                                                                               ||
||        ShowPricePoints Routine Procedure        v1.00         Date 11.11.2009        KTL      ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     Create the typical Open High Low and close price displayed at the top left      ||
||               corner of the price window.                                                     ||
||                                                                                               ||
||  Note:        This was also included to be compatable with the design of MQ chart layout, and ||
||               can be removed with the user extern imput ShowOHLC imput. This header will show ||
||               more then once if more then two charts are put on the same indicator window. It ||
||               will not show on any indicator applied to the main chart window. Added was the  ||
||               clone warning to the title bar of the chart.                                    ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    ShowPricePoints( string Pair, double oPrice, double hPrice, double lPrice, double cPrice ) {
        int      DigitCount     =   0;
        string   StringOHLC     =  "";
        string   CloneWarning   =  "";

            CloneWarning  =  "      WARNING:   This Chart\'s Data Is Out Dated.";
            DigitCount    =  MarketInfo( Pair, MODE_DIGITS );
            StringOHLC    =  StringConcatenate( " ", DoubleToStr( oPrice, DigitCount ),
                                              " ", DoubleToStr( hPrice, DigitCount ),
                                              " ", DoubleToStr( lPrice, DigitCount ),
                                              " ", DoubleToStr( cPrice, DigitCount ),
                                              "              " );

            IndicatorShortName( IndicatorName + " " + StringOHLC );

            if( ! CloneUpDated )   {   IndicatorShortName( IndicatorName + CloneWarning );   }

    return;

} // End Routine Procedure, ShowPricePoints:




/*===============================================================================================|\
||                                                                                               ||
||  ClearAllBarGraphic Routine Procedure        v1.00      Date 11.11.2009           KTL         ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     This will remove all the objects that this indicator creates. All other objects ||
||               created by other sources will not be removed. Including ones created by other   ||
||               copies of this indicator.                                                       ||
||                                                                                               ||
||  Parameters:  Each copy of this indicator has full knowledge of its own objects and will not  ||
||               remove any objects that were created by any other sources or by any other       ||
||               copies of this same indicator as all copies are Uniquely Identified and will    ||
||               only remove its own objects.                                                    ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    ClearAllBarGraphic( string Object ) {

            for( int Count = ObjectsTotal(); Count >= 0; Count -- )

                if( StringSubstr( ObjectName( Count ), 0, 18 ) == Object )
                    ObjectDelete( ObjectName( Count ));

    return;

} // End Routine Procedure, ClearAllBarGraphic:




/*--End-Code--//
//    DOCUMENTATION DIVISION    
//




                                  May Be Added On A Later Date




//
//    END PROGRAM SCRIPT;        MetaQuote Source Code [ mq4 ]    
// [rev.01-01-2009] */




